From 335a9fb2dfb67605ffd69a5017107d71534f872a Mon Sep 17 00:00:00 2001
From: Dominik Bartkiewicz <bart@schedmd.com>
Date: Wed, 4 May 2022 13:06:36 -0600
Subject: [PATCH 01/34] Prevent credential abuse.

CVE-2022-29500
---
 NEWS                                          |   1 +
 src/api/config_info.c                         |   1 +
 src/api/job_info.c                            |   2 +
 src/api/job_step_info.c                       |   2 +
 src/api/node_info.c                           |   1 +
 src/api/pmi_server.c                          |   1 +
 src/api/reconfigure.c                         |   1 +
 src/api/signal.c                              |   3 +
 src/api/slurm_pmi.c                           |   3 +
 src/api/step_launch.c                         |   2 +
 src/bcast/file_bcast.c                        |   1 +
 src/common/forward.c                          |   5 +-
 src/common/slurm_auth.c                       |  34 ++-
 src/common/slurm_auth.h                       |  16 +-
 src/common/slurm_persist_conn.c               |   1 +
 src/common/slurm_persist_conn.h               |   1 +
 src/common/slurm_protocol_api.c               | 224 +++++++++++++++++-
 src/common/slurm_protocol_api.h               |   3 +
 src/common/slurm_protocol_defs.c              |   4 +
 src/common/slurm_protocol_defs.h              |  14 ++
 src/common/slurmdb_defs.c                     |   1 +
 src/common/slurmdbd_defs.c                    |   1 +
 src/common/stepd_api.c                        |   3 +-
 src/common/stepd_api.h                        |   3 +-
 .../accounting_storage/common/common_as.c     |   1 +
 src/plugins/auth/munge/auth_munge.c           |  64 +++--
 src/plugins/auth/none/auth_none.c             |  17 +-
 src/plugins/mpi/pmi2/setup.c                  |   1 +
 src/plugins/mpi/pmi2/setup.h                  |   1 +
 src/plugins/mpi/pmi2/spawn.c                  |   3 +-
 src/plugins/mpi/pmix/pmixp_utils.c            |   1 +
 src/sattach/sattach.c                         |   1 +
 src/slurmctld/agent.c                         |  19 ++
 src/slurmctld/agent.h                         |   4 +
 src/slurmctld/backup.c                        |   9 +-
 src/slurmctld/controller.c                    |   1 +
 src/slurmctld/fed_mgr.c                       |   2 +
 src/slurmctld/job_mgr.c                       |  12 +-
 src/slurmctld/job_scheduler.c                 |   2 +
 src/slurmctld/node_mgr.c                      |   2 +-
 src/slurmctld/node_scheduler.c                |   3 +
 src/slurmctld/ping_nodes.c                    |   4 +
 src/slurmctld/srun_comm.c                     |  36 ++-
 src/slurmctld/step_mgr.c                      |   3 +
 src/slurmd/slurmd/req.c                       |  21 +-
 src/slurmd/slurmd/slurmd.c                    |   6 +-
 src/slurmd/slurmstepd/io.c                    |   1 +
 src/slurmd/slurmstepd/mgr.c                   |  16 +-
 src/slurmd/slurmstepd/mgr.h                   |   2 +-
 src/slurmd/slurmstepd/req.c                   |   1 +
 src/slurmd/slurmstepd/slurmstepd.c            |  21 +-
 src/slurmd/slurmstepd/slurmstepd_job.c        |   7 +-
 src/slurmd/slurmstepd/slurmstepd_job.h        |   4 +-
 src/slurmdbd/read_config.c                    |   1 +
 src/slurmdbd/slurmdbd.c                       |   1 +
 55 files changed, 521 insertions(+), 74 deletions(-)

diff --git a/NEWS b/NEWS
index 073e3cbee3..7791dc8ca9 100644
--- a/NEWS
+++ b/NEWS
@@ -1,6 +1,7 @@
 This file describes changes in recent versions of Slurm. It primarily
 documents those changes that are of interest to users and administrators.
 
+ -- CVE-2022-29500 - Prevent credential abuse.
  -- CVE-2022-29501 - Prevent abuse of REQUEST_FORWARD_DATA.
 
 * Changes in Slurm 17.02.11
diff --git a/src/api/config_info.c b/src/api/config_info.c
index ae8c2e784a..d31eb0f4db 100644
--- a/src/api/config_info.c
+++ b/src/api/config_info.c
@@ -1794,6 +1794,7 @@ slurm_load_slurmd_status(slurmd_status_t **slurmd_status_ptr)
 	}
 	req_msg.msg_type = REQUEST_DAEMON_STATUS;
 	req_msg.data     = NULL;
+	slurm_msg_set_r_uid(&req_msg, SLURM_AUTH_UID_ANY);
 
 	rc = slurm_send_recv_node_msg(&req_msg, &resp_msg, 0);
 
diff --git a/src/api/job_info.c b/src/api/job_info.c
index aa8be2d61c..eccac89d0d 100644
--- a/src/api/job_info.c
+++ b/src/api/job_info.c
@@ -1179,6 +1179,7 @@ slurm_pid2jobid (pid_t job_pid, uint32_t *jobid)
 	req.job_pid      = job_pid;
 	req_msg.msg_type = REQUEST_JOB_ID;
 	req_msg.data     = &req;
+	slurm_msg_set_r_uid(&req_msg, SLURM_AUTH_UID_ANY);
 
 	rc = slurm_send_recv_node_msg(&req_msg, &resp_msg, 0);
 
@@ -1553,6 +1554,7 @@ slurm_network_callerid (network_callerid_msg_t req, uint32_t *job_id,
 
 	req_msg.msg_type = REQUEST_NETWORK_CALLERID;
 	req_msg.data     = &req;
+	slurm_msg_set_r_uid(&req_msg, SLURM_AUTH_UID_ANY);
 
 	if (slurm_send_recv_node_msg(&req_msg, &resp_msg, 0) < 0)
 		return SLURM_ERROR;
diff --git a/src/api/job_step_info.c b/src/api/job_step_info.c
index 8a1a64b725..320fcd5707 100644
--- a/src/api/job_step_info.c
+++ b/src/api/job_step_info.c
@@ -444,6 +444,7 @@ extern int slurm_job_step_stat(uint32_t job_id, uint32_t step_id,
               job_id, step_id, node_list);
 
 	slurm_msg_t_init(&req_msg);
+	slurm_msg_set_r_uid(&req_msg, SLURM_AUTH_UID_ANY);
 
 	memset(&req, 0, sizeof(job_step_id_msg_t));
 	resp_out->job_id = req.job_id = job_id;
@@ -560,6 +561,7 @@ extern int slurm_job_step_get_pids(uint32_t job_id, uint32_t step_id,
               job_id, step_id, node_list);
 
 	slurm_msg_t_init(&req_msg);
+	slurm_msg_set_r_uid(&req_msg, SLURM_AUTH_UID_ANY);
 
 	memset(&req, 0, sizeof(job_step_id_msg_t));
         resp_out->job_id = req.job_id = job_id;
diff --git a/src/api/node_info.c b/src/api/node_info.c
index 9de3682185..290799cf17 100644
--- a/src/api/node_info.c
+++ b/src/api/node_info.c
@@ -670,6 +670,7 @@ extern int slurm_get_node_energy(char *host, uint16_t delta,
 	req.delta        = delta;
 	req_msg.msg_type = REQUEST_ACCT_GATHER_ENERGY;
 	req_msg.data     = &req;
+	slurm_msg_set_r_uid(&req_msg, SLURM_AUTH_UID_ANY);
 
 	rc = slurm_send_recv_node_msg(&req_msg, &resp_msg, 0);
 
diff --git a/src/api/pmi_server.c b/src/api/pmi_server.c
index 577c541b14..d5015fc949 100644
--- a/src/api/pmi_server.c
+++ b/src/api/pmi_server.c
@@ -147,6 +147,7 @@ static void *_msg_thread(void *x)
 	slurm_msg_t msg_send;
 
 	slurm_msg_t_init(&msg_send);
+	slurm_msg_set_r_uid(&msg_send, SLURM_AUTH_UID_ANY);
 
 	debug2("KVS_Barrier msg to %s:%hu",
 		msg_arg_ptr->bar_ptr->hostname,
diff --git a/src/api/reconfigure.c b/src/api/reconfigure.c
index c3c118afb6..85adfbe50a 100644
--- a/src/api/reconfigure.c
+++ b/src/api/reconfigure.c
@@ -159,6 +159,7 @@ _send_message_controller (enum controller_id dest, slurm_msg_t *req)
 	if ((fd = slurm_open_controller_conn_spec(dest)) < 0)
 		slurm_seterrno_ret(SLURMCTLD_COMMUNICATIONS_CONNECTION_ERROR);
 
+	slurm_msg_set_r_uid(req, slurm_conf.slurm_user_id);
 	if (slurm_send_node_msg(fd, req) < 0) {
 		slurm_shutdown_msg_conn(fd);
 		slurm_seterrno_ret(SLURMCTLD_COMMUNICATIONS_SEND_ERROR);
diff --git a/src/api/signal.c b/src/api/signal.c
index a157fa63f4..c4932a477b 100644
--- a/src/api/signal.c
+++ b/src/api/signal.c
@@ -59,6 +59,7 @@ static int _local_send_recv_rc_msgs(const char *nodelist,
 	slurm_msg_t *msg = xmalloc(sizeof(slurm_msg_t));
 
 	slurm_msg_t_init(msg);
+	slurm_msg_set_r_uid(msg, SLURM_AUTH_UID_ANY);
 	msg->msg_type = type;
 	msg->data = data;
 
@@ -99,6 +100,7 @@ static int _signal_batch_script_step(const resource_allocation_response_msg_t
 	rpc.signal = signal;
 
 	slurm_msg_t_init(&msg);
+	slurm_msg_set_r_uid(&msg, slurm_conf.slurmd_user_id);
 	msg.msg_type = REQUEST_SIGNAL_TASKS;
 	msg.data = &rpc;
 	if (slurm_conf_get_addr(name, &msg.address) == SLURM_ERROR) {
@@ -153,6 +155,7 @@ static int _terminate_batch_script_step(const resource_allocation_response_msg_t
 
 	slurm_msg_t_init(&msg);
 	msg.msg_type = REQUEST_TERMINATE_TASKS;
+	slurm_msg_set_r_uid(&msg, slurm_conf.slurmd_user_id);
 	msg.data = &rpc;
 
 	if (slurm_conf_get_addr(name, &msg.address) == SLURM_ERROR) {
diff --git a/src/api/slurm_pmi.c b/src/api/slurm_pmi.c
index b4a8108a3a..50455094dc 100644
--- a/src/api/slurm_pmi.c
+++ b/src/api/slurm_pmi.c
@@ -177,6 +177,7 @@ int slurm_send_kvs_comm_set(kvs_comm_set_t *kvs_set_ptr,
 	_set_pmi_time();
 
 	slurm_msg_t_init(&msg_send);
+	slurm_msg_set_r_uid(&msg_send, SLURM_AUTH_UID_ANY);
 	msg_send.address = srun_addr;
 	msg_send.msg_type = PMI_KVS_PUT_REQ;
 	msg_send.data = (void *) kvs_set_ptr;
@@ -259,6 +260,7 @@ int  slurm_get_kvs_comm_set(kvs_comm_set_t **kvs_set_ptr,
 	data.port = port;
 	data.hostname = hostname;
 	slurm_msg_t_init(&msg_send);
+	slurm_msg_set_r_uid(&msg_send, SLURM_AUTH_UID_ANY);
 	slurm_msg_t_init(&msg_rcv);
 	msg_send.address = srun_addr;
 	msg_send.msg_type = PMI_KVS_GET_REQ;
@@ -343,6 +345,7 @@ static int _forward_comm_set(kvs_comm_set_t *kvs_set_ptr)
 		if (kvs_set_ptr->kvs_host_ptr[i].port == 0)
 			continue;	/* empty */
 		slurm_msg_t_init(&msg_send);
+		slurm_msg_set_r_uid(&msg_send, SLURM_AUTH_UID_ANY);
 		msg_send.msg_type = PMI_KVS_GET_RESP;
 		msg_send.data = (void *) kvs_set_ptr;
 		slurm_set_addr(&msg_send.address,
diff --git a/src/api/step_launch.c b/src/api/step_launch.c
index 4a66c7b99b..89abead8aa 100644
--- a/src/api/step_launch.c
+++ b/src/api/step_launch.c
@@ -804,6 +804,7 @@ void slurm_step_launch_fwd_signal(slurm_step_ctx_t *ctx, int signo)
 	hostlist_destroy(hl);
 
 	slurm_msg_t_init(&req);
+	slurm_msg_set_r_uid(&req, SLURM_AUTH_UID_ANY);
 	req.msg_type = REQUEST_SIGNAL_TASKS;
 	req.data     = &msg;
 
@@ -1650,6 +1651,7 @@ static int _launch_tasks(slurm_step_ctx_t *ctx,
 	}
 
 	slurm_msg_t_init(&msg);
+	slurm_msg_set_r_uid(&msg, SLURM_AUTH_UID_ANY);
 	msg.msg_type = REQUEST_LAUNCH_TASKS;
 	msg.data = launch_msg;
 
diff --git a/src/bcast/file_bcast.c b/src/bcast/file_bcast.c
index 13d45f6e9d..ed79decd01 100644
--- a/src/bcast/file_bcast.c
+++ b/src/bcast/file_bcast.c
@@ -176,6 +176,7 @@ static int _file_bcast(struct bcast_parameters *params,
 	slurm_msg_t msg;
 
 	slurm_msg_t_init(&msg);
+	slurm_msg_set_r_uid(&msg, SLURM_AUTH_UID_ANY);
 	msg.data = bcast_msg;
 	msg.msg_type = REQUEST_FILE_BCAST;
 
diff --git a/src/common/forward.c b/src/common/forward.c
index 703d72eb0c..09fb435756 100644
--- a/src/common/forward.c
+++ b/src/common/forward.c
@@ -250,7 +250,7 @@ void *_forward_thread(void *arg)
 			/*      steps, fwd_msg->timeout); */
 		}
 
-		ret_list = slurm_receive_msgs(fd, steps, fwd_msg->timeout);
+		ret_list = slurm_receive_resp_msgs(fd, steps, fwd_msg->timeout);
 		/* info("sent %d forwards got %d back", */
 		/*      fwd_msg->header.forward.cnt, list_count(ret_list)); */
 
@@ -358,6 +358,9 @@ void *_fwd_tree_thread(void *arg)
 	send_msg.msg_type = fwd_tree->orig_msg->msg_type;
 	send_msg.data = fwd_tree->orig_msg->data;
 	send_msg.protocol_version = fwd_tree->orig_msg->protocol_version;
+	if (fwd_tree->orig_msg->restrict_uid_set)
+		slurm_msg_set_r_uid(&send_msg,
+				    fwd_tree->orig_msg->restrict_uid);
 
 	/* repeat until we are sure the message was sent */
 	while ((name = hostlist_shift(fwd_tree->tree_hl))) {
diff --git a/src/common/slurm_auth.c b/src/common/slurm_auth.c
index f7811e71aa..7ce0887ead 100644
--- a/src/common/slurm_auth.c
+++ b/src/common/slurm_auth.c
@@ -60,7 +60,8 @@ static bool init_run = false;
  * end of the structure.
  */
 typedef struct slurm_auth_ops {
-        void *       (*create)    ( char *auth_info );
+        void *       (*create)    ( char *auth_infouid_t, uid_t r_uid,
+				    void *data, int dlen);
         int          (*destroy)   ( void *cred );
         int          (*verify)    ( void *cred, char *auth_info );
         uid_t        (*get_uid)   ( void *cred, char *auth_info );
@@ -70,6 +71,9 @@ typedef struct slurm_auth_ops {
         int          (*print)     ( void *cred, FILE *fp );
         int          (*sa_errno)  ( void *cred );
         const char * (*sa_errstr) ( int slurm_errno );
+	bool	     (*hash_enable);
+        int	     (*get_data)  (void *cred, char **data,
+					 uint32_t *len);
 } slurm_auth_ops_t;
 /*
  * These strings must be kept in the same order as the fields
@@ -85,7 +89,9 @@ static const char *syms[] = {
 	"slurm_auth_unpack",
 	"slurm_auth_print",
 	"slurm_auth_errno",
-	"slurm_auth_errstr"
+        "slurm_auth_errstr",
+	"hash_enable",
+	"auth_p_get_data"
 };
 
 /*
@@ -125,6 +131,15 @@ slurm_auth_generic_errstr( int slurm_errno )
         }
 }
 
+extern bool slurm_get_plugin_hash_enable(int index)
+{
+       if (slurm_auth_init(NULL) < 0)
+               return true;
+
+       return *(ops[index].hash_enable);
+
+}
+
 extern int slurm_auth_init( char *auth_type )
 {
         int retval = SLURM_SUCCESS;
@@ -182,12 +197,13 @@ slurm_auth_fini( void )
  * the API function dispatcher.
  */
 
-void *g_slurm_auth_create(char *auth_info)
+void *g_slurm_auth_create(char *auth_info, uid_t r_uid,
+			  void *data, int dlen)
 {
 	if (slurm_auth_init(NULL) < 0)
 		return NULL;
 
-        return (*(ops.create))(auth_info);
+	return (*(ops.create))(auth_info, r_uid, data, dlen);
 }
 
 int g_slurm_auth_destroy(void *cred)
@@ -206,6 +222,16 @@ int g_slurm_auth_verify(void *cred, char *auth_info)
         return (*(ops.verify))(cred, auth_info);
 }
 
+int auth_g_get_data(void *cred, char **data, uint32_t *len)
+{
+	cred_wrapper_t *wrap = (cred_wrapper_t *) cred;
+
+	if (!wrap || slurm_auth_init(NULL) < 0)
+		return SLURM_ERROR;
+
+	return (*(ops[wrap->index].get_data))(cred, data, len);
+}
+
 uid_t g_slurm_auth_get_uid(void *cred, char *auth_info)
 {
 	if (slurm_auth_init(NULL) < 0)
diff --git a/src/common/slurm_auth.h b/src/common/slurm_auth.h
index b430809ca5..f7ab7ac68e 100644
--- a/src/common/slurm_auth.h
+++ b/src/common/slurm_auth.h
@@ -88,6 +88,12 @@ enum {
 	ARG_COUNT,
 };
 
+/*
+ * This should be equal to MUNGE_UID_ANY
+ * do not restrict decode via uid
+ */
+#define SLURM_AUTH_UID_ANY -1
+
 /*
  * SLURM authentication context opaque type.
  */
@@ -128,15 +134,23 @@ extern int slurm_auth_init( char *auth_type );
  */
 extern int slurm_auth_fini( void );
 
+/*
+ * Check if plugin type corresponding to the authentication
+ * plugin index supports hash.
+ */
+extern bool slurm_get_plugin_hash_enable(int index);
+
 /*
  * Static bindings for the global authentication context.
  */
-extern void *	g_slurm_auth_create(char *auth_info);
+extern void *	g_slurm_auth_create(char *auth_info, uid_t r_uid,
+				 void *data, int dlen);
 extern int	g_slurm_auth_destroy( void *cred );
 extern int	g_slurm_auth_verify(void *cred, char *auth_info);
 extern uid_t	g_slurm_auth_get_uid( void *cred, char *auth_info );
 extern gid_t	g_slurm_auth_get_gid( void *cred, char *auth_info );
 extern int	g_slurm_auth_pack( void *cred, Buf buf );
+extern int      auth_g_get_data(void *cred, char **data, uint32_t *len);
 
 /*
  * WARNING!  The returned auth pointer WILL have pointers
diff --git a/src/common/slurm_persist_conn.c b/src/common/slurm_persist_conn.c
index 3146e1c867..bfee739097 100644
--- a/src/common/slurm_persist_conn.c
+++ b/src/common/slurm_persist_conn.c
@@ -575,6 +575,7 @@ extern int slurm_persist_conn_open(slurm_persist_conn_t *persist_conn)
 	req_msg.flags |= SLURM_GLOBAL_AUTH_KEY;
 	if (persist_conn->flags & PERSIST_FLAG_DBD)
 		req_msg.flags |= SLURMDBD_CONNECTION;
+	slurm_msg_set_r_uid(&req_msg, persist_conn->r_uid);
 
 	memset(&req, 0, sizeof(persist_init_req_msg_t));
 	req.cluster_name = persist_conn->cluster_name;
diff --git a/src/common/slurm_persist_conn.h b/src/common/slurm_persist_conn.h
index ece44280f5..0d128aab6f 100644
--- a/src/common/slurm_persist_conn.h
+++ b/src/common/slurm_persist_conn.h
@@ -61,6 +61,7 @@ typedef struct {
 	int fd;
 	uint16_t flags;
 	bool inited;
+	uid_t r_uid;
 	char *rem_host;
 	uint16_t rem_port;
 	time_t *shutdown;
diff --git a/src/common/slurm_protocol_api.c b/src/common/slurm_protocol_api.c
index ed2f866d0e..f97b6be357 100644
--- a/src/common/slurm_protocol_api.c
+++ b/src/common/slurm_protocol_api.c
@@ -869,6 +869,36 @@ char *slurm_get_priority_weight_tres(void)
 	return weights;
 }
 
+static int _check_hash(buf_t *buffer, header_t *header, slurm_msg_t *msg,
+		       void *cred)
+{
+	char *cred_hash = NULL;
+	uint32_t cred_hash_len = 0;
+	int rc;
+	static time_t config_update = (time_t) -1;
+	static bool block_null_hash = true;
+
+	if (config_update != slurm_conf.last_update) {
+		block_null_hash = (xstrcasestr(slurm_conf.comm_params,
+					       "block_null_hash"));
+		config_update = slurm_conf.last_update;
+	}
+
+	rc = auth_g_get_data(cred, &cred_hash, &cred_hash_len);
+
+	if (cred_hash || cred_hash_len) {
+		if (cred_hash_len != 3 || cred_hash[0] != 1 ||
+		    memcmp(cred_hash + 1,
+			   &msg->msg_type, sizeof(msg->msg_type)))
+			rc = SLURM_ERROR;
+	} else if (block_null_hash &&
+		   slurm_get_plugin_hash_enable(msg->auth_index))
+		rc = SLURM_ERROR;
+
+	xfree(cred_hash);
+	return rc;
+}
+
 static int _get_tres_id(char *type, char *name)
 {
 	slurmdb_tres_rec_t tres_rec;
@@ -3190,6 +3220,9 @@ extern int slurm_unpack_received_msg(slurm_msg_t *msg, int fd, Buf buffer)
 		goto total_return;
 	}
 
+	msg->auth_uid = g_slurm_auth_get_uid(auth_cred);
+	msg->auth_uid_set = true;
+
 	/*
 	 * Unpack message body
 	 */
@@ -3200,6 +3233,7 @@ extern int slurm_unpack_received_msg(slurm_msg_t *msg, int fd, Buf buffer)
 	body_offset = get_buf_offset(buffer);
 
 	if ((header.body_length > remaining_buf(buffer)) ||
+	    _check_hash(buffer, &header, msg, auth_cred) ||
 	    (unpack_msg(msg, buffer) != SLURM_SUCCESS)) {
 		rc = ESLURM_PROTOCOL_INCOMPLETE_PACKET;
 		(void) g_slurm_auth_destroy(auth_cred);
@@ -3304,6 +3338,8 @@ int slurm_receive_msg(int fd, slurm_msg_t *msg, int timeout)
 	 */
 	if (slurm_msg_recvfrom_timeout(fd, &buf, &buflen, 0, timeout) < 0) {
 		rc = errno;
+		if (!rc)
+			rc = SLURMCTLD_COMMUNICATIONS_RECEIVE_ERROR;
 		goto endit;
 	}
 
@@ -3466,6 +3502,8 @@ List slurm_receive_msgs(int fd, int steps, int timeout)
 		goto total_return;
 	}
 
+	msg.auth_uid = g_slurm_auth_get_uid(auth_cred);
+	msg.auth_uid_set = true;
 	/*
 	 * Unpack message body
 	 */
@@ -3474,6 +3512,7 @@ List slurm_receive_msgs(int fd, int steps, int timeout)
 	msg.flags = header.flags;
 
 	if ((header.body_length > remaining_buf(buffer)) ||
+	    _check_hash(buffer, &header, &msg, auth_cred) ||
 	    (unpack_msg(&msg, buffer) != SLURM_SUCCESS)) {
 		(void) g_slurm_auth_destroy(auth_cred);
 		free_buf(buffer);
@@ -3515,6 +3554,155 @@ total_return:
 
 }
 
+List slurm_receive_resp_msgs(int fd, int steps, int timeout)
+{
+	char *buf = NULL;
+	size_t buflen = 0;
+	header_t header;
+	int rc;
+	void *auth_cred = NULL;
+	slurm_msg_t msg;
+	buf_t *buffer;
+	ret_data_info_t *ret_data_info = NULL;
+	List ret_list = NULL;
+	int orig_timeout = timeout;
+
+	xassert(fd >= 0);
+
+	slurm_msg_t_init(&msg);
+	msg.conn_fd = fd;
+
+	if (timeout <= 0) {
+		/* convert secs to msec */
+		timeout = slurm_conf.msg_timeout * 1000;
+		orig_timeout = timeout;
+	}
+	if (steps) {
+		if (message_timeout < 0)
+			message_timeout = slurm_conf.msg_timeout * 1000;
+		orig_timeout = (timeout -
+				(message_timeout*(steps-1)))/steps;
+		steps--;
+	}
+
+	log_flag(NET, "%s: orig_timeout was %d we have %d steps and a timeout of %d",
+		 __func__, orig_timeout, steps, timeout);
+	/* we compare to the orig_timeout here because that is really
+	 *  what we are going to wait for each step
+	 */
+	if (orig_timeout >= (slurm_conf.msg_timeout * 10000)) {
+		log_flag(NET, "%s: Sending a message with timeout's greater than %d seconds, requested timeout is %d seconds",
+			 __func__, (slurm_conf.msg_timeout * 10),
+			 (timeout/1000));
+	} else if (orig_timeout < 1000) {
+		log_flag(NET, "%s: Sending a message with a very short timeout of %d milliseconds each step in the tree has %d milliseconds",
+			 __func__, timeout, orig_timeout);
+	}
+
+
+	/*
+	 * Receive a msg. slurm_msg_recvfrom() will read the message
+	 *  length and allocate space on the heap for a buffer containing
+	 *  the message.
+	 */
+	if (slurm_msg_recvfrom_timeout(fd, &buf, &buflen, 0, timeout) < 0) {
+		forward_init(&header.forward);
+		rc = errno;
+		goto total_return;
+	}
+
+	log_flag_hex(NET_RAW, buf, buflen, "%s: read", __func__);
+	buffer = create_buf(buf, buflen);
+
+	if (unpack_header(&header, buffer) == SLURM_ERROR) {
+		free_buf(buffer);
+		rc = SLURM_COMMUNICATIONS_RECEIVE_ERROR;
+		goto total_return;
+	}
+
+	if (check_header_version(&header) < 0) {
+		slurm_addr_t resp_addr;
+		if (!slurm_get_peer_addr(fd, &resp_addr)) {
+			error("%s: Invalid Protocol Version %u from at %pA",
+			      __func__, header.version, &resp_addr);
+		} else {
+			error("%s: Invalid Protocol Version %u from problem connection: %m",
+			      __func__, header.version);
+		}
+
+		free_buf(buffer);
+		rc = SLURM_PROTOCOL_VERSION_ERROR;
+		goto total_return;
+	}
+	//info("ret_cnt = %d",header.ret_cnt);
+	if (header.ret_cnt > 0) {
+		if (header.ret_list)
+			ret_list = header.ret_list;
+		else
+			ret_list = list_create(destroy_data_info);
+		header.ret_cnt = 0;
+		header.ret_list = NULL;
+	}
+
+	/* Forward message to other nodes */
+	if (header.forward.cnt > 0) {
+		error("%s: We need to forward this to other nodes use slurm_receive_msg_and_forward instead",
+		      __func__);
+	}
+
+	if (!(auth_cred = g_slurm_auth_unpack(buffer, header.version))) {
+		error("%s: auth_g_unpack: %m", __func__);
+		free_buf(buffer);
+		rc = ESLURM_PROTOCOL_INCOMPLETE_PACKET;
+		goto total_return;
+	}
+	g_slurm_auth_destroy(auth_cred);
+	/*
+	 * Unpack message body
+	 */
+	msg.protocol_version = header.version;
+	msg.msg_type = header.msg_type;
+	msg.flags = header.flags;
+
+	if ((header.body_length > remaining_buf(buffer)) ||
+	    (unpack_msg(&msg, buffer) != SLURM_SUCCESS)) {
+		free_buf(buffer);
+		rc = ESLURM_PROTOCOL_INCOMPLETE_PACKET;
+		goto total_return;
+	}
+	free_buf(buffer);
+	rc = SLURM_SUCCESS;
+
+total_return:
+	destroy_forward(&header.forward);
+
+	if (rc != SLURM_SUCCESS) {
+		if (ret_list) {
+			ret_data_info = xmalloc(sizeof(ret_data_info_t));
+			ret_data_info->err = rc;
+			ret_data_info->type = RESPONSE_FORWARD_FAILED;
+			ret_data_info->data = NULL;
+			list_push(ret_list, ret_data_info);
+		}
+
+		error("%s: failed: %s",
+		      __func__, slurm_strerror(rc));
+		usleep(10000);	/* Discourage brute force attack */
+	} else {
+		if (!ret_list)
+			ret_list = list_create(destroy_data_info);
+		ret_data_info = xmalloc(sizeof(ret_data_info_t));
+		ret_data_info->err = rc;
+		ret_data_info->node_name = NULL;
+		ret_data_info->type = msg.msg_type;
+		ret_data_info->data = msg.data;
+		list_push(ret_list, ret_data_info);
+	}
+
+	errno = rc;
+	return ret_list;
+
+}
 /* try to determine the UID associated with a message with different
  * message header version, return -1 if we can't tell */
 static int _unpack_msg_uid(Buf buffer)
@@ -3700,6 +3888,9 @@ int slurm_receive_msg_and_forward(int fd, slurm_addr_t *orig_addr,
 		goto total_return;
 	}
 
+	msg->auth_uid = g_slurm_auth_get_uid(auth_cred);
+	msg->auth_uid_set = true;
+
 	/*
 	 * Unpack message body
 	 */
@@ -3713,6 +3904,7 @@ int slurm_receive_msg_and_forward(int fd, slurm_addr_t *orig_addr,
 	}
 
 	if ( (header.body_length > remaining_buf(buffer)) ||
+	    _check_hash(buffer, &header, msg, auth_cred) ||
 	     (unpack_msg(msg, buffer) != SLURM_SUCCESS) ) {
 		(void) g_slurm_auth_destroy(auth_cred);
 		free_buf(buffer);
@@ -3780,6 +3972,7 @@ int slurm_send_node_msg(int fd, slurm_msg_t * msg)
 	int      rc;
 	void *   auth_cred;
 	time_t   start_time = time(NULL);
+	unsigned char auth_payload[3] = { 1 }; /* uint8_t + uint16_t (msg_type) */
 
 	if (msg->conn) {
 		persist_msg_t persist_msg;
@@ -3811,6 +4004,9 @@ int slurm_send_node_msg(int fd, slurm_msg_t * msg)
 		return rc;
 	}
 
+	if (!msg->restrict_uid_set)
+		fatal("%s: restrict_uid is not set", __func__);
+	memcpy(auth_payload + 1, &msg->msg_type, sizeof(msg->msg_type));
 	/*
 	 * Initialize header with Auth credential and message type.
 	 * We get the credential now rather than later so the work can
@@ -3819,10 +4015,14 @@ int slurm_send_node_msg(int fd, slurm_msg_t * msg)
 	 * wait too long for the incoming message.
 	 */
 	if (msg->flags & SLURM_GLOBAL_AUTH_KEY) {
-		auth_cred = g_slurm_auth_create(_global_auth_key());
+		auth_cred = g_slurm_auth_create(_global_auth_key(),
+						msg->restrict_uid, auth_payload,
+						sizeof(auth_payload));
 	} else {
 		char *auth_info = slurm_get_auth_info();
-		auth_cred = g_slurm_auth_create(auth_info);
+		auth_cred = g_slurm_auth_create(auth_info,
+						msg->restrict_uid, auth_payload,
+						sizeof(auth_payload));
 		xfree(auth_info);
 	}
 
@@ -3839,10 +4039,16 @@ int slurm_send_node_msg(int fd, slurm_msg_t * msg)
 	if (difftime(time(NULL), start_time) >= 60) {
 		(void) g_slurm_auth_destroy(auth_cred);
 		if (msg->flags & SLURM_GLOBAL_AUTH_KEY) {
-			auth_cred = g_slurm_auth_create(_global_auth_key());
+			auth_cred = g_slurm_auth_create(_global_auth_key(),
+							msg->restrict_uid,
+							auth_payload,
+							sizeof(auth_payload));
 		} else {
 			char *auth_info = slurm_get_auth_info();
-			auth_cred = g_slurm_auth_create(auth_info);
+			auth_cred = g_slurm_auth_create(auth_info,
+							msg->restrict_uid,
+							auth_payload,
+							sizeof(auth_payload));
 			xfree(auth_info);
 		}
 	}
@@ -4313,6 +4519,7 @@ int slurm_send_recv_controller_msg(slurm_msg_t *req, slurm_msg_t *resp)
 	forward_init(&req->forward, NULL);
 	req->ret_list = NULL;
 	req->forward_struct = NULL;
+	slurm_msg_set_r_uid(req, SLURM_AUTH_UID_ANY);
 
 	if (working_cluster_rec)
 		req->flags |= SLURM_GLOBAL_AUTH_KEY;
@@ -4413,6 +4620,8 @@ int slurm_send_only_controller_msg(slurm_msg_t *req)
 		goto cleanup;
 	}
 
+	slurm_msg_set_r_uid(req, slurm_conf.slurm_user_id);
+
 	if ((rc = slurm_send_node_msg(fd, req)) < 0) {
 		rc = SLURM_ERROR;
 	} else {
@@ -4700,6 +4909,12 @@ extern void slurm_free_msg(slurm_msg_t *msg)
 	}
 }
 
+extern void slurm_msg_set_r_uid(slurm_msg_t *msg, uid_t r_uid)
+{
+	msg->restrict_uid = r_uid;
+	msg->restrict_uid_set = true;
+}
+
 extern char *nodelist_nth_host(const char *nodelist, int inx)
 {
 	hostlist_t hl = hostlist_create(nodelist);
@@ -4896,6 +5111,7 @@ extern int slurm_forward_data(
 	req.len = len;
 	req.data = (char *)data;
 
+	slurm_msg_set_r_uid(&msg, SLURM_AUTH_UID_ANY);
 	msg.msg_type = REQUEST_FORWARD_DATA;
 	msg.data = &req;
 
diff --git a/src/common/slurm_protocol_api.h b/src/common/slurm_protocol_api.h
index ab324b42a0..4fa8ed6ec2 100644
--- a/src/common/slurm_protocol_api.h
+++ b/src/common/slurm_protocol_api.h
@@ -1019,6 +1019,7 @@ int slurm_receive_msg(int fd, slurm_msg_t *msg, int timeout);
  *                errno set.
  */
 List slurm_receive_msgs(int fd, int steps, int timeout);
+List slurm_receive_resp_msgs(int fd, int steps, int timeout);
 
 /*
  *  Receive a slurm message on the open slurm descriptor "fd" waiting
@@ -1289,6 +1290,8 @@ extern int *set_span(int total, uint16_t tree_width);
 extern void slurm_free_msg_members(slurm_msg_t *msg);
 extern void slurm_free_msg(slurm_msg_t * msg);
 
+extern void slurm_msg_set_r_uid(slurm_msg_t *msg, uid_t r_uid);
+
 /* must free this memory with free not xfree */
 extern char *nodelist_nth_host(const char *nodelist, int inx);
 extern int nodelist_find(const char *nodelist, const char *name);
diff --git a/src/common/slurm_protocol_defs.c b/src/common/slurm_protocol_defs.c
index d633fbcb2b..e8fc1ea850 100644
--- a/src/common/slurm_protocol_defs.c
+++ b/src/common/slurm_protocol_defs.c
@@ -51,6 +51,7 @@
 #include "src/common/power.h"
 #include "src/common/slurm_accounting_storage.h"
 #include "src/common/slurm_acct_gather_energy.h"
+#include "src/common/slurm_auth.h"
 #include "src/common/slurm_cred.h"
 #include "src/common/slurm_ext_sensors.h"
 #include "src/common/slurm_jobacct_gather.h"
@@ -104,6 +105,7 @@ extern void slurm_msg_t_init(slurm_msg_t *msg)
 {
 	memset(msg, 0, sizeof(slurm_msg_t));
 
+	msg->auth_uid = SLURM_AUTH_NOBODY;
 	msg->conn_fd = -1;
 	msg->msg_type = (uint16_t)NO_VAL;
 	msg->protocol_version = (uint16_t)NO_VAL;
@@ -129,6 +131,8 @@ extern void slurm_msg_t_copy(slurm_msg_t *dest, slurm_msg_t *src)
 	dest->ret_list = src->ret_list;
 	dest->forward_struct = src->forward_struct;
 	dest->orig_addr.sin_addr.s_addr = 0;
+	if (src->auth_uid_set)
+		slurm_msg_set_r_uid(dest, src->auth_uid);
 	return;
 }
 
diff --git a/src/common/slurm_protocol_defs.h b/src/common/slurm_protocol_defs.h
index 286461d1bb..abca229509 100644
--- a/src/common/slurm_protocol_defs.h
+++ b/src/common/slurm_protocol_defs.h
@@ -50,6 +50,7 @@
 #include "src/common/job_options.h"
 #include "src/common/list.h"
 #include "src/common/macros.h"
+#include "src/common/slurm_auth.h"
 #include "src/common/slurm_cred.h"
 #include "src/common/slurm_protocol_common.h"
 #include "src/common/slurm_persist_conn.h"
@@ -452,6 +453,19 @@ typedef struct slurm_protocol_config {
 typedef struct slurm_msg {
 	slurm_addr_t address;
 	void *auth_cred;
+	uid_t auth_uid;		/* NEVER PACK. Authenticated uid from auth
+				 * credential. Only valid if auth_uid_set is
+				 * true. Set to SLURM_AUTH_NOBODY if not set
+				 * yet.
+				 */
+	bool auth_uid_set;	/* NEVER PACK. True when auth_uid has been set.
+				 * This is a safety measure against handling
+				 * a slurm_msg_t that has been xmalloc()'d but
+				 * slurm_msg_t_init() was not called since
+				 * auth_uid would be root.
+				 */
+	uid_t restrict_uid;
+	bool restrict_uid_set;
 	Buf buffer; /* DON't PACK! ptr to buffer that msg was unpacked from. */
 	slurm_persist_conn_t *conn; /* DON'T PACK OR FREE! this is here to
 				     * distinquish a persistant connection from
diff --git a/src/common/slurmdb_defs.c b/src/common/slurmdb_defs.c
index 73c51ea792..332c4a7ea3 100644
--- a/src/common/slurmdb_defs.c
+++ b/src/common/slurmdb_defs.c
@@ -2897,6 +2897,7 @@ extern int slurmdb_send_accounting_update(List update_list, char *cluster,
 	slurm_set_addr_char(&req.address, port, host);
 
 	req.protocol_version = rpc_version;
+	slurm_msg_set_r_uid(&req, SLURM_AUTH_UID_ANY);
 
 	req.msg_type = ACCOUNTING_UPDATE_MSG;
 	if (slurmdbd_conf)
diff --git a/src/common/slurmdbd_defs.c b/src/common/slurmdbd_defs.c
index 112c46f590..5f95999626 100644
--- a/src/common/slurmdbd_defs.c
+++ b/src/common/slurmdbd_defs.c
@@ -445,6 +445,7 @@ static void _open_slurmdbd_conn(bool need_db)
 			slurm_set_accounting_storage_port(
 				slurmdbd_conn->rem_port);
 		}
+		slurmdbd_conn->r_uid = SLURM_AUTH_UID_ANY;
 	}
 	slurmdbd_shutdown = 0;
 	slurmdbd_conn->shutdown = &slurmdbd_shutdown;
diff --git a/src/common/stepd_api.c b/src/common/stepd_api.c
index 6e2deec93a..4fb3a7c497 100644
--- a/src/common/stepd_api.c
+++ b/src/common/stepd_api.c
@@ -473,7 +473,7 @@ rwfail:
 int
 stepd_attach(int fd, uint16_t protocol_version,
 	     slurm_addr_t *ioaddr, slurm_addr_t *respaddr,
-	     void *job_cred_sig, reattach_tasks_response_msg_t *resp)
+	     void *job_cred_sig, uid_t uid, reattach_tasks_response_msg_t *resp)
 {
 	int req = REQUEST_ATTACH;
 	int rc = SLURM_SUCCESS;
@@ -483,6 +483,7 @@ stepd_attach(int fd, uint16_t protocol_version,
 	safe_write(fd, ioaddr, sizeof(slurm_addr_t));
 	safe_write(fd, respaddr, sizeof(slurm_addr_t));
 	safe_write(fd, job_cred_sig, SLURM_IO_KEY_SIZE);
+	safe_write(fd, &uid, sizeof(uid_t));
 	safe_write(fd, &proto, sizeof(int));
 
 	/* Receive the return code */
diff --git a/src/common/stepd_api.h b/src/common/stepd_api.h
index a700c81f55..06a61f82c0 100644
--- a/src/common/stepd_api.h
+++ b/src/common/stepd_api.h
@@ -187,7 +187,8 @@ int stepd_signal_container(int fd, uint16_t protocol_version, int signal);
  */
 int stepd_attach(int fd, uint16_t protocol_version,
 		 slurm_addr_t *ioaddr, slurm_addr_t *respaddr,
-		 void *job_cred_sig, reattach_tasks_response_msg_t *resp);
+		 void *job_cred_sig, uid_t uid,
+		 reattach_tasks_response_msg_t *resp);
 
 /*
  * Scan for available running slurm step daemons by checking
